import * as i0 from '@angular/core';
import { signal, computed, Component, ChangeDetectionStrategy, ViewEncapsulation, Input, NgModule } from '@angular/core';
import * as i1 from '@angular/common';
import { NgClass, NgIf } from '@angular/common';

class ButtonComponent {
    constructor() {
        this.disabled$ = signal(false);
        this.buttonStyle$ = signal('primary');
        this.fab$ = signal(false);
        this.text$ = signal(false);
        this.outlined$ = signal(false);
        this.icon$ = signal(null);
        this.iconSrc$ = signal(null);
        this.buttonStyleClasses$ = computed(() => {
            const classes = ['sp-button', `button-${this.buttonStyle$()}`];
            if (this.text$()) {
                classes.push('button-text');
            }
            if (this.outlined$()) {
                classes.push('button-text-outlined');
            }
            if (this.fab$()) {
                classes.push('fab');
            }
            return classes.join(' ');
        });
    }
    set disabled(disabled) {
        this.disabled$.set(disabled);
    }
    set buttonStyle(buttonStyle) {
        this.buttonStyle$.set(buttonStyle);
    }
    set fab(fab) {
        this.fab$.set(fab);
    }
    set text(text) {
        this.text$.set(text);
    }
    set outlined(outlined) {
        this.outlined$.set(outlined);
    }
    set icon(icon) {
        this.icon$.set(icon);
    }
    set iconSrc(iconSrc) {
        this.iconSrc$.set(iconSrc);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: ButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.0.8", type: ButtonComponent, selector: "button[sp-button]", inputs: { disabled: "disabled", buttonStyle: "buttonStyle", fab: "fab", text: "text", outlined: "outlined", icon: "icon", iconSrc: "iconSrc" }, host: { properties: { "class": "buttonStyleClasses$()", "attr.disabled": "disabled$() || null" } }, ngImport: i0, template: "@if (iconSrc$() != null) {\r\n    <img class=\"sp-button-icon\" [src]=\"iconSrc$()\" alt=\"Button Icon\" />\r\n} @else if (iconSrc$() == null && icon$() != null) {\r\n    <i class=\"sp-button-icon\" [ngClass]=\"icon$()\"></i>\r\n}\r\n<span class=\"sp-button-label\">\r\n    <ng-content></ng-content>\r\n</span>\r\n", styles: [""], dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: ButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'button[sp-button]', changeDetection: ChangeDetectionStrategy.OnPush, host: {
                        '[class]': 'buttonStyleClasses$()',
                        '[attr.disabled]': 'disabled$() || null'
                    }, encapsulation: ViewEncapsulation.None, template: "@if (iconSrc$() != null) {\r\n    <img class=\"sp-button-icon\" [src]=\"iconSrc$()\" alt=\"Button Icon\" />\r\n} @else if (iconSrc$() == null && icon$() != null) {\r\n    <i class=\"sp-button-icon\" [ngClass]=\"icon$()\"></i>\r\n}\r\n<span class=\"sp-button-label\">\r\n    <ng-content></ng-content>\r\n</span>\r\n" }]
        }], propDecorators: { disabled: [{
                type: Input
            }], buttonStyle: [{
                type: Input
            }], fab: [{
                type: Input
            }], text: [{
                type: Input
            }], outlined: [{
                type: Input
            }], icon: [{
                type: Input
            }], iconSrc: [{
                type: Input
            }] } });

class ButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: ButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.0.8", ngImport: i0, type: ButtonModule, declarations: [ButtonComponent], imports: [NgClass,
            NgIf], exports: [ButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: ButtonModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: ButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ButtonComponent
                    ],
                    imports: [
                        NgClass,
                        NgIf
                    ],
                    exports: [
                        ButtonComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of button
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ButtonComponent, ButtonModule };
//# sourceMappingURL=spicysources-button.mjs.map
